/***************************************************************************
 *   Copyright (C) 2006 by the KSmoothDock team   *
 *   dangvd@yahoo.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "task.h"

#include <qcursor.h>

#include <klocale.h>
#include <kpopupmenu.h>
#include <kwin.h>
#include <netwm.h>

#include "ksmoothdock.h"

Task::Task() {}

Task::Task(KSmoothDock* parent, int itemId, QString desc, int desktop, QPixmap& icon, int minSize, int maxSize, Qt::Orientation orientation, int winId)
 : IconBasedDockItem(parent, itemId, desc, desktop, icon, minSize, maxSize, orientation), m_winId(winId)
{
}

/** 
 * Mouse pressed event handler
 */

void Task::mousePressEvent(QMouseEvent* e) {
    if (e->button() == Qt::LeftButton) { // if left-click, set focus on the task
        KWin::forceActiveWindow(m_winId);
    } else { // if right-click, display the task's popup menu
        KPopupMenu appMenu;
        appMenu.insertItem(i18n("Mi&nimize"), this, SLOT(minTask()));
        appMenu.insertItem(i18n("Ma&ximize"), this, SLOT(maxTask()));
        appMenu.insertSeparator();
        appMenu.insertItem(i18n("&Close"), this, SLOT(closeTask()));
        appMenu.exec(QCursor::pos());
    }
}

/** 
 * Return window id
 */

WId Task::getWinId() {
    return m_winId;
}

void Task::minTask() {
    KWin::iconifyWindow(m_winId);
}

void Task::maxTask() {
    KWin::setState(m_winId, NET::MaxVert + NET::MaxHoriz);
}

void Task::closeTask() {
    NETRootInfo root(qt_xdisplay(), NET::CloseWindow);
    root.closeWindowRequest(m_winId);
}

